# v3.0 features

## Update logs
- 10/18/2016 (Last Update)
- 10/01/2016
- 08/19/2016
- 07/18/2016
- 07/13/2016
- 07/04/2016
- 07/04/2016

## Validation Result
- [x] top level validation properties
  - [x] valid
  - [x] invalid
  - [x] touched
  - [x] untouched
  - [x] pristine
  - [x] dirty
  - [x] modified
  - [x] errors
- [x] field level validation properties
  - [x] valid
  - [x] invalid
  - [x] touched
  - [x] untouched
  - [x] pristine
  - [x] dirty
  - [x] modified
  - [x] errors

## Validator Syntax
- [x] Literal
  - [x] Array
  - [x] Object
- [x] Binding
- [x] Dynamic Attribute
- [x] Camel-case

## Built-in Validators
- [x] required
- [x] pattern
- [x] minlength
- [x] maxlength
- [x] min
- [x] max

## Validatable Elements
- [x] input (text/number/email/url/ ...)
- [x] checkbox
- [x] radio
- [x] select
- [x] component <sup>NEW</sup>

## v-model Integration
- [x] elements
  - [x] input (text/number/email/url/ ...)
  - [x] checkbox
  - [x] radio
  - [x] select
  - [x] component <sup>NEW</sup>
- [x] v-model value control <sup>NEW</sup>

## Validation Classes
- [x] basic
- [x] local custom classes
- [x] global custom classes <sup>NEW</sup>

## Grouping
- [x] basic
- [x] component <sup>NEW</sup>

## Error Messages
- [x] global registration
- [x] local registration
- ~~enumration~~ <sup>DEPRECATED, use your component</sup>
  - ~~defautl component template~~
  - ~~custom component template~~
  - ~~default partial template~~
  - ~~custom partial template~~
  - ~~group message focusing~~
  - ~~filed message focusing~~

## Events
- ~~top level validation event~~ <sup>DEPRECATED, use $watch or watch option</sup>
  - ~~valid~~
  - ~~invalid~~
  - ~~touched~~
  - ~~dirty~~
  - ~~modified~~
- [x] field level validatoin event
  - [x] valid
  - [x] invalid
  - [x] touched
  - [x] dirty
  - [x] modified

## Custom Validator
- [x] global registration
- [x] local registration
- [x] error message

## Validation Timing Customization
- ~~initial~~ <sup>DEPRECATED, use DOM event handling</sup>
- ~~detect-blur~~ <sup>DEPRECATED, use event DOM handling</sup>
- ~~detect-change~~ <sup>DEPRECATED, use event DOM handling</sup>

## Async Validation
- [x] function
- [x] promise
- [x] progress status <sup>NEW</sup>

## API
### Vue global enhancement
- [x] Vue.validator

### Vue constructor options enhancement
- [x] validators

### Vue instance meta methods <sup>DEPRECATED, use Validity class</sup>
- ~~$activeValidator~~
- ~~$resetValidation~~
- ~~$setValidationErrors~~
- ~~$validate~~
- ~~$validates~~

### Directive
- ~~v-validate~~<sup>DEPRECATED, use validity component</sup>
- ~~v-validate-class~~~~<sup>DEPRECATED, use validity component</sup>

### Special Elements (Components)
- ~~validator~~ <sup>DEPRECATED, use the validation component</sup>
- ~~validator-errors~~ <sup>DEPRECATED</sup>
- [x] validity <sup>NEW</sup>
  - [ ] methods
    - [x] validate
    - [x] reset
    - [ ] active
    - [ ] deactive
    - [ ] setErrors
  - [x] properties
    - [x] valid
    - [x] invalid
    - [x] touched
    - [x] untouched
    - [x] pristine
    - [x] dirty
    - [x] modified
    - [x] errors
    - [x] progresses
- [x] validity-group (for multiple checkbox or radio)<sup>NEW</sup>
- [x] validation <sup>NEW</sup>
